



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ORACLE 当字段中有数据如何修改字段类型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ORACLE 当字段中有数据如何修改字段类型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 18:10:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>创建视图的时候，因为表太多，里面一些字段类型不一样，PL/SQL报错，为&lsquo;表达式必须具有对应表达式相同的数据类型&rsquo;，发现后，一个字段的类型为CLOB和VARCHAR2(4000)两种，将CLOB进行修改</p>
<p>将CLOB字段修改成varchar2(4000)字段</p>
<p>第一步：把原字段换个名字，此条的sql是把C_009700010003换成C_0097000100031</p>
<p>alter table 表名 rename column&nbsp; 当前字段 to 备用字段;</p>
<div>
<pre class="prettyprint linenums">alter table T_00970001 rename column  C_009700010003 to C_0097000100031;</pre>
</div>
<p>第二步：在表中添加一个原字段名字C_009700010003 ，并把类型定义自己想改变的类型， 此条是定义VARCHAR2类型</p>
<p>alter table 表名 add 新增字段名称 字段类型;</p>
<div>
<pre class="prettyprint linenums">alter table T_00970001 add C_009700010003 VARCHAR2(4000);</pre>
</div>
<p>第三步：养成良好的习惯，将字段名称进行备注，以免以后忘记字段名称。</p>
<div>
<pre class="prettyprint linenums">comment on column T_00970001.C_009700010003 is '处罚事由';</pre>
</div>
<p>第四步：这条语句是把备份的C_0097000100031字段内容 添加到新建字段C_009700010003 中来，这条语句就是把CLOB类型的数据转换成varchar2类型在插入到新定义的C_009700010003</p>
<p>update 表名 set 新增字段名称 = dbms_lob.substr(备用字段,4000);</p>
<div>
<pre class="prettyprint linenums">update T_00970001 set C_009700010003 = dbms_lob.substr(C_0097000100031,4000);</pre>
</div>
<p>第五步：把备份字段C_0097000100031去掉</p>
<div>
<pre class="prettyprint linenums">alter table T_00970001 drop column C_0097000100031;</pre>
</div>
<p>第四步的dbms_lob的用法，我整理了下：</p>
<p>我第四步中是截取前4000.</p>
<p>CLOB里存的是2进制</p>
<p>判定长度 &nbsp; DBMS_LOB.GETLENGTH(col1)<br />
获取文本 &nbsp; DBMS_LOB.SUBSTR(col1,n,pos)<br />
DBMS_LOB.SUBSTR(col1,10,1)表示从第1个字节开始取出10个字节</p>
<p>DBMS_LOB.SUBSTR(CLOB_VAR,32767)表示截取CLOB变量保存的全部数据</p>
<p>DBMS_LOB.FILECLOSE(IMG_BFILE)关闭文件</p>
<p>clob转化为字符串，SELECT &nbsp;<br />
UTL_RAW.CAST_TO_VARCHAR2(DBMS_LOB.SUBSTR(col1,10,1))<br />
&nbsp; FROM &nbsp; tab1;</p>
<p>如果clob中包含空格则不能使用。</p>
<p>将clob类型转化成字符串</p>
<div>
<pre class="prettyprint linenums">create   or   replace   function   getclob(<br />
          table_name             in   varchar2,<br />
          field_id               in   varchar2,<br />
          field_name             in   varchar2,<br />
          v_id                   in   number,<br />
          v_pos                  in   number)   return   varchar2<br />
is<br />
          lobloc                 clob;<br />
          buffer                 varchar2(32767);<br />
          amount                 number   :=   2000;<br />
          offset                 number   :=   1;<br />
          query_str              varchar2(1000);<br />
begin<br />
      query_str   := 'select   '||field_name|| '   from   '||table_name|| '   where   '||field_id|| '=   :id   ';<br />
      EXECUTE   IMMEDIATE   query_str   INTO   lobloc   USING   v_id;<br />
      offset:=offset+(v_pos-1)*2000;<br />
      dbms_lob.read(lobloc,amount,offset,buffer);<br />
               return   buffer;<br />
exception<br />
        when   no_data_found   then<br />
               return   buffer;<br />
end;</pre>
</div>
<p>当然了，还有一个更简单的方法。</p>
<p>那就是</p>
<p>先利用第三方工具软件PL/sql把数据导出来，而后修改数据结构，即修改数据类型，最后就重新往新的表插入数据。<br />alter table filename<br />modify 字段名 varchar2(4000)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rp5je8.html">Redis笔记（七）Java实现Redis消息队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql02l1q.html">Fiddler---前端利器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xy1mg9.html">android默认浏览器response下载PDF文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd7m7r8.html">Spring 使用注解方式进行事物管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgznd48.html">aop切入点表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1dxoxq.html">简单的划分数问题&amp;lt&semi;划分问题&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16mzzq.html">git submodule 删除及更新URL 转载的</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdlg39.html">Nginx  反向代理如何连接上游服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gn0m0q.html">CSS 基础：定位元素&lpar;3&rpar;&amp;lt&semi;思维导图&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2o4719.html">RzPageControl 关闭按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzo569.html">Android  Autosizing TextViews</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6o658.html">DBeaver连接Oracle11g数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25okwvq.html">LinkedHashMap 实现总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ppe4w8.html">koa项目用mongoose与mongodb交互，始终报错FormModel is not defined</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvov4xq.html">51nod 1494 选举拉票 &vert; 线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4wy2xq.html">彻底抛弃脚本录制，LR脚本之使用web&lowbar;custom&lowbar;request函数自定义http请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p1zx08.html">Tornado源码分析 --- Etag实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emllox9.html">How to use Qt Designed Ui file</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmwyr09.html">ARM开发板搭建NFS网络文件共享方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9536lrv8.html">【饿了么】&mdash;&mdash; Vue2&period;0高仿饿了么核心模块&amp;amp&semi;移动端Web App项目爬坑（三）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zykl6v9.html">C语言 大小写字母转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o14o41q.html">《Java大学教程》&mdash;第17章 Java聚焦类框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjo4k39.html">MYSQL的binlog日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2en4z9.html">jvisualVM的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll12g1q.html">docker实战练习（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjp7e09.html">Control4系统对接arduino</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5n2geq.html">ESP8266 HTTP 项目（1）在刻度盘上进行ESP8266 NodeMCU模拟读取的步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyv75mq.html">from &lowbar;&lowbar;future&lowbar;&lowbar; import包的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvno1j8.html">leetcode 557&period; Reverse Words in a String III 、151&period; Reverse Words in a String</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll14vxq.html">springboot配置文件中使用当前配置的变量</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
